from datetime import datetime

import pandas as pd


def dataset_union():
    gridID_list = [2408, 2409, 2410, 2343, 2344, 2472, 2473, 2474, 2475, 2407,
                   2411, 2412, 2413, 2345, 2346, 2347, 2348, 2279, 2280,
                   2281, 2282, 2283, 2214, 2215, 2216, 2217, 2218, 2148,
                   2149, 2150, 2151, 2152, 2342, 2277, 2212, 2146, 2147, 2213, 2278]

    vodafoneGrelha_agosto = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Agosto_2022.csv", sep=',')
    vodafoneGrelha_agosto = vodafoneGrelha_agosto[vodafoneGrelha_agosto['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_setembro = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Setembro_2022.csv", sep=',')
    vodafoneGrelha_setembro = vodafoneGrelha_setembro[vodafoneGrelha_setembro['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_outubro = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Outubro_2022.csv", sep=',')
    vodafoneGrelha_outubro = vodafoneGrelha_outubro[vodafoneGrelha_outubro['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_novembro = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Novembro_2022.csv", sep=',')
    vodafoneGrelha_novembro = vodafoneGrelha_novembro[vodafoneGrelha_novembro['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_dezembro = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Dezembro_2022.csv", sep=',')
    vodafoneGrelha_dezembro = vodafoneGrelha_dezembro[vodafoneGrelha_dezembro['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_janeiro = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Janeiro_2023.csv", sep=',')
    vodafoneGrelha_janeiro = vodafoneGrelha_janeiro[vodafoneGrelha_janeiro['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_fevereiro = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Fevereiro_2023.csv", sep=',')
    vodafoneGrelha_fevereiro = vodafoneGrelha_fevereiro[vodafoneGrelha_fevereiro['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_março = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Março_2023.csv", sep=',')
    vodafoneGrelha_março = vodafoneGrelha_março[vodafoneGrelha_março['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_abril = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Abril_2023.csv", sep=',')
    vodafoneGrelha_abril = vodafoneGrelha_abril[vodafoneGrelha_abril['Grid_ID'].isin(gridID_list)]

    vodafoneGrelha_maio = pd.read_csv(
        "D:\ISCTE\Internet das Coisas\D\PgilVodafone_Maio_2023.csv", sep=',')
    vodafoneGrelha_maio = vodafoneGrelha_maio[vodafoneGrelha_maio['Grid_ID'].isin(gridID_list)]

    frames = [vodafoneGrelha_agosto, vodafoneGrelha_setembro, vodafoneGrelha_outubro,
              vodafoneGrelha_novembro, vodafoneGrelha_dezembro, vodafoneGrelha_janeiro,
              vodafoneGrelha_fevereiro, vodafoneGrelha_março,
              vodafoneGrelha_abril, vodafoneGrelha_maio]
    dataset = pd.concat(frames)

    dataset.to_csv("MobilidadeLisboa.csv")


def dataset_clean():
    dataset = pd.read_csv("MobilidadeLisboa.csv")
    jogos_benfica = pd.read_csv("D:\ISCTE\Internet das Coisas\D\Jogos Benfica.csv", sep=';')
    grelha_lisboa = pd.read_csv("D:\ISCTE\Internet das Coisas\D\VODAFONE_QUADRICULAS\VODAFONE_QUADRICULAS.csv", sep=';')

    collumns_to_remove = ["Unnamed: 0", 'C2', 'C3', 'C4', 'C5', 'C6', 'C7', 'C8', 'C9',
                          'C10', 'C11', 'D1', 'E1', 'E2', 'E3', 'E4', 'E5', 'E6', 'E7', 'E8',
                          'E9', 'E10']

    dataset = dataset.drop(collumns_to_remove, axis=1)

    dataset['Time'] = pd.to_datetime(dataset['Datetime']).dt.time
    dataset["Date"] = pd.to_datetime(dataset["Datetime"], format='%Y-%m-%dT%H:%M:%S.%fZ').dt.date
    jogos_benfica["Data"] = pd.to_datetime(jogos_benfica["Data"], format='%Y-%m-%d').dt.date

    dataset["Game day"] = "No"
    for data in jogos_benfica["Data"]:
        dataset.loc[dataset['Date'] == data, "Game day"] = "Yes"

    grelha_lisboa.rename(columns={"grelha_id": "Grid_ID"}, inplace=True)
    dataset = pd.merge(dataset, grelha_lisboa[['Grid_ID', 'latitude', 'longitude']], on='Grid_ID', how='left')

    print(dataset.columns)
    print(dataset.head())

    dataset.to_csv("MobilidadeLisboa_limpo.csv")


def main():
    dataset_union()
    dataset_clean()


if __name__ == "__main__":
    main()
